<script setup lang="ts">
  const emit = defineEmits(['close']);

  const slots = useSlots();

  const close = () => emit('close');

  withDefaults(
    defineProps<{
      loading?: boolean;
      showCloseBtn?: boolean;
    }>(),
    {
      loading: false,
      showCloseBtn: true,
    },
  );
</script>
<template>
  <aside class="shadow-5 z-sidebar border-border flex h-full w-full flex-col justify-between">
    <div
      v-if="slots.header"
      name="sidebar-header"
      class="border-border bg-background-raised relative flex items-start justify-between border-b p-6"
    >
      <slot name="header" :close="close"></slot>

      <SwButton
        v-if="showCloseBtn"
        variant="action"
        class="!absolute right-6 top-6 z-10 !p-2"
        @click="close"
      >
        <span class="i-sw-solid:times-circle text-base" />
      </SwButton>
    </div>

    <div class="relative min-h-0 w-full flex-1 bg-white">
      <SwLoading
        v-if="loading"
        class="text-primary z-loading absolute inset-0 bg-white/80 text-3xl"
      />

      <div name="sidebar-body" class="h-full w-full overflow-y-scroll">
        <slot name="body" />
      </div>
    </div>

    <div name="sidebar-footer" class="w-full">
      <slot name="footer" />
    </div>
  </aside>
</template>
